# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = ['BigQueryConnectionArgs', 'BigQueryConnection']

@pulumi.input_type
class BigQueryConnectionArgs:
    def __init__(__self__, *,
                 auth_provider_x509_cert_url: pulumi.Input[builtins.str],
                 auth_uri: pulumi.Input[builtins.str],
                 client_email: pulumi.Input[builtins.str],
                 client_id: pulumi.Input[builtins.str],
                 client_x509_cert_url: pulumi.Input[builtins.str],
                 gcp_project_id: pulumi.Input[builtins.str],
                 private_key: pulumi.Input[builtins.str],
                 private_key_id: pulumi.Input[builtins.str],
                 project_id: pulumi.Input[builtins.int],
                 timeout_seconds: pulumi.Input[builtins.int],
                 token_uri: pulumi.Input[builtins.str],
                 type: pulumi.Input[builtins.str],
                 application_id: Optional[pulumi.Input[builtins.str]] = None,
                 application_secret: Optional[pulumi.Input[builtins.str]] = None,
                 dataproc_cluster_name: Optional[pulumi.Input[builtins.str]] = None,
                 dataproc_region: Optional[pulumi.Input[builtins.str]] = None,
                 execution_project: Optional[pulumi.Input[builtins.str]] = None,
                 gcs_bucket: Optional[pulumi.Input[builtins.str]] = None,
                 is_active: Optional[pulumi.Input[builtins.bool]] = None,
                 location: Optional[pulumi.Input[builtins.str]] = None,
                 maximum_bytes_billed: Optional[pulumi.Input[builtins.int]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 priority: Optional[pulumi.Input[builtins.str]] = None,
                 retries: Optional[pulumi.Input[builtins.int]] = None):
        """
        The set of arguments for constructing a BigQueryConnection resource.
        :param pulumi.Input[builtins.str] auth_provider_x509_cert_url: Auth Provider X509 Cert URL for the Service Account
        :param pulumi.Input[builtins.str] auth_uri: Auth URI for the Service Account
        :param pulumi.Input[builtins.str] client_email: Service Account email
        :param pulumi.Input[builtins.str] client_id: Client ID of the Service Account
        :param pulumi.Input[builtins.str] client_x509_cert_url: Client X509 Cert URL for the Service Account
        :param pulumi.Input[builtins.str] gcp_project_id: GCP project ID
        :param pulumi.Input[builtins.str] private_key: Private key of the Service Account
        :param pulumi.Input[builtins.str] private_key_id: Private key ID of the Service Account
        :param pulumi.Input[builtins.int] project_id: Project ID to create the connection in
        :param pulumi.Input[builtins.int] timeout_seconds: Timeout in seconds for queries
        :param pulumi.Input[builtins.str] token_uri: Token URI for the Service Account
        :param pulumi.Input[builtins.str] type: The type of connection
        :param pulumi.Input[builtins.str] application_id: The Application ID for BQ OAuth
        :param pulumi.Input[builtins.str] application_secret: The Application Secret for BQ OAuth
        :param pulumi.Input[builtins.str] dataproc_cluster_name: Dataproc cluster name for PySpark workloads
        :param pulumi.Input[builtins.str] dataproc_region: Google Cloud region for PySpark workloads on Dataproc
        :param pulumi.Input[builtins.str] execution_project: Project to bill for query execution
        :param pulumi.Input[builtins.str] gcs_bucket: URI for a Google Cloud Storage bucket to host Python code executed via Datapro
        :param pulumi.Input[builtins.bool] is_active: Whether the connection is active
        :param pulumi.Input[builtins.str] location: Location to create new Datasets in
        :param pulumi.Input[builtins.int] maximum_bytes_billed: Max number of bytes that can be billed for a given BigQuery query
        :param pulumi.Input[builtins.str] name: Connection name
        :param pulumi.Input[builtins.str] priority: The priority with which to execute BigQuery queries (batch or interactive)
        :param pulumi.Input[builtins.int] retries: Number of retries for queries
        """
        pulumi.set(__self__, "auth_provider_x509_cert_url", auth_provider_x509_cert_url)
        pulumi.set(__self__, "auth_uri", auth_uri)
        pulumi.set(__self__, "client_email", client_email)
        pulumi.set(__self__, "client_id", client_id)
        pulumi.set(__self__, "client_x509_cert_url", client_x509_cert_url)
        pulumi.set(__self__, "gcp_project_id", gcp_project_id)
        pulumi.set(__self__, "private_key", private_key)
        pulumi.set(__self__, "private_key_id", private_key_id)
        pulumi.set(__self__, "project_id", project_id)
        pulumi.set(__self__, "timeout_seconds", timeout_seconds)
        pulumi.set(__self__, "token_uri", token_uri)
        pulumi.set(__self__, "type", type)
        if application_id is not None:
            pulumi.set(__self__, "application_id", application_id)
        if application_secret is not None:
            pulumi.set(__self__, "application_secret", application_secret)
        if dataproc_cluster_name is not None:
            pulumi.set(__self__, "dataproc_cluster_name", dataproc_cluster_name)
        if dataproc_region is not None:
            pulumi.set(__self__, "dataproc_region", dataproc_region)
        if execution_project is not None:
            pulumi.set(__self__, "execution_project", execution_project)
        if gcs_bucket is not None:
            pulumi.set(__self__, "gcs_bucket", gcs_bucket)
        if is_active is not None:
            pulumi.set(__self__, "is_active", is_active)
        if location is not None:
            pulumi.set(__self__, "location", location)
        if maximum_bytes_billed is not None:
            pulumi.set(__self__, "maximum_bytes_billed", maximum_bytes_billed)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if priority is not None:
            pulumi.set(__self__, "priority", priority)
        if retries is not None:
            pulumi.set(__self__, "retries", retries)

    @property
    @pulumi.getter(name="authProviderX509CertUrl")
    def auth_provider_x509_cert_url(self) -> pulumi.Input[builtins.str]:
        """
        Auth Provider X509 Cert URL for the Service Account
        """
        return pulumi.get(self, "auth_provider_x509_cert_url")

    @auth_provider_x509_cert_url.setter
    def auth_provider_x509_cert_url(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "auth_provider_x509_cert_url", value)

    @property
    @pulumi.getter(name="authUri")
    def auth_uri(self) -> pulumi.Input[builtins.str]:
        """
        Auth URI for the Service Account
        """
        return pulumi.get(self, "auth_uri")

    @auth_uri.setter
    def auth_uri(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "auth_uri", value)

    @property
    @pulumi.getter(name="clientEmail")
    def client_email(self) -> pulumi.Input[builtins.str]:
        """
        Service Account email
        """
        return pulumi.get(self, "client_email")

    @client_email.setter
    def client_email(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "client_email", value)

    @property
    @pulumi.getter(name="clientId")
    def client_id(self) -> pulumi.Input[builtins.str]:
        """
        Client ID of the Service Account
        """
        return pulumi.get(self, "client_id")

    @client_id.setter
    def client_id(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "client_id", value)

    @property
    @pulumi.getter(name="clientX509CertUrl")
    def client_x509_cert_url(self) -> pulumi.Input[builtins.str]:
        """
        Client X509 Cert URL for the Service Account
        """
        return pulumi.get(self, "client_x509_cert_url")

    @client_x509_cert_url.setter
    def client_x509_cert_url(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "client_x509_cert_url", value)

    @property
    @pulumi.getter(name="gcpProjectId")
    def gcp_project_id(self) -> pulumi.Input[builtins.str]:
        """
        GCP project ID
        """
        return pulumi.get(self, "gcp_project_id")

    @gcp_project_id.setter
    def gcp_project_id(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "gcp_project_id", value)

    @property
    @pulumi.getter(name="privateKey")
    def private_key(self) -> pulumi.Input[builtins.str]:
        """
        Private key of the Service Account
        """
        return pulumi.get(self, "private_key")

    @private_key.setter
    def private_key(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "private_key", value)

    @property
    @pulumi.getter(name="privateKeyId")
    def private_key_id(self) -> pulumi.Input[builtins.str]:
        """
        Private key ID of the Service Account
        """
        return pulumi.get(self, "private_key_id")

    @private_key_id.setter
    def private_key_id(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "private_key_id", value)

    @property
    @pulumi.getter(name="projectId")
    def project_id(self) -> pulumi.Input[builtins.int]:
        """
        Project ID to create the connection in
        """
        return pulumi.get(self, "project_id")

    @project_id.setter
    def project_id(self, value: pulumi.Input[builtins.int]):
        pulumi.set(self, "project_id", value)

    @property
    @pulumi.getter(name="timeoutSeconds")
    def timeout_seconds(self) -> pulumi.Input[builtins.int]:
        """
        Timeout in seconds for queries
        """
        return pulumi.get(self, "timeout_seconds")

    @timeout_seconds.setter
    def timeout_seconds(self, value: pulumi.Input[builtins.int]):
        pulumi.set(self, "timeout_seconds", value)

    @property
    @pulumi.getter(name="tokenUri")
    def token_uri(self) -> pulumi.Input[builtins.str]:
        """
        Token URI for the Service Account
        """
        return pulumi.get(self, "token_uri")

    @token_uri.setter
    def token_uri(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "token_uri", value)

    @property
    @pulumi.getter
    def type(self) -> pulumi.Input[builtins.str]:
        """
        The type of connection
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "type", value)

    @property
    @pulumi.getter(name="applicationId")
    def application_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The Application ID for BQ OAuth
        """
        return pulumi.get(self, "application_id")

    @application_id.setter
    def application_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "application_id", value)

    @property
    @pulumi.getter(name="applicationSecret")
    def application_secret(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The Application Secret for BQ OAuth
        """
        return pulumi.get(self, "application_secret")

    @application_secret.setter
    def application_secret(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "application_secret", value)

    @property
    @pulumi.getter(name="dataprocClusterName")
    def dataproc_cluster_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Dataproc cluster name for PySpark workloads
        """
        return pulumi.get(self, "dataproc_cluster_name")

    @dataproc_cluster_name.setter
    def dataproc_cluster_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "dataproc_cluster_name", value)

    @property
    @pulumi.getter(name="dataprocRegion")
    def dataproc_region(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Google Cloud region for PySpark workloads on Dataproc
        """
        return pulumi.get(self, "dataproc_region")

    @dataproc_region.setter
    def dataproc_region(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "dataproc_region", value)

    @property
    @pulumi.getter(name="executionProject")
    def execution_project(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Project to bill for query execution
        """
        return pulumi.get(self, "execution_project")

    @execution_project.setter
    def execution_project(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "execution_project", value)

    @property
    @pulumi.getter(name="gcsBucket")
    def gcs_bucket(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        URI for a Google Cloud Storage bucket to host Python code executed via Datapro
        """
        return pulumi.get(self, "gcs_bucket")

    @gcs_bucket.setter
    def gcs_bucket(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "gcs_bucket", value)

    @property
    @pulumi.getter(name="isActive")
    def is_active(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Whether the connection is active
        """
        return pulumi.get(self, "is_active")

    @is_active.setter
    def is_active(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "is_active", value)

    @property
    @pulumi.getter
    def location(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Location to create new Datasets in
        """
        return pulumi.get(self, "location")

    @location.setter
    def location(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "location", value)

    @property
    @pulumi.getter(name="maximumBytesBilled")
    def maximum_bytes_billed(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        Max number of bytes that can be billed for a given BigQuery query
        """
        return pulumi.get(self, "maximum_bytes_billed")

    @maximum_bytes_billed.setter
    def maximum_bytes_billed(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "maximum_bytes_billed", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Connection name
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def priority(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The priority with which to execute BigQuery queries (batch or interactive)
        """
        return pulumi.get(self, "priority")

    @priority.setter
    def priority(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "priority", value)

    @property
    @pulumi.getter
    def retries(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        Number of retries for queries
        """
        return pulumi.get(self, "retries")

    @retries.setter
    def retries(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "retries", value)


@pulumi.input_type
class _BigQueryConnectionState:
    def __init__(__self__, *,
                 application_id: Optional[pulumi.Input[builtins.str]] = None,
                 application_secret: Optional[pulumi.Input[builtins.str]] = None,
                 auth_provider_x509_cert_url: Optional[pulumi.Input[builtins.str]] = None,
                 auth_uri: Optional[pulumi.Input[builtins.str]] = None,
                 client_email: Optional[pulumi.Input[builtins.str]] = None,
                 client_id: Optional[pulumi.Input[builtins.str]] = None,
                 client_x509_cert_url: Optional[pulumi.Input[builtins.str]] = None,
                 connection_id: Optional[pulumi.Input[builtins.int]] = None,
                 dataproc_cluster_name: Optional[pulumi.Input[builtins.str]] = None,
                 dataproc_region: Optional[pulumi.Input[builtins.str]] = None,
                 execution_project: Optional[pulumi.Input[builtins.str]] = None,
                 gcp_project_id: Optional[pulumi.Input[builtins.str]] = None,
                 gcs_bucket: Optional[pulumi.Input[builtins.str]] = None,
                 is_active: Optional[pulumi.Input[builtins.bool]] = None,
                 is_configured_for_oauth: Optional[pulumi.Input[builtins.bool]] = None,
                 location: Optional[pulumi.Input[builtins.str]] = None,
                 maximum_bytes_billed: Optional[pulumi.Input[builtins.int]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 priority: Optional[pulumi.Input[builtins.str]] = None,
                 private_key: Optional[pulumi.Input[builtins.str]] = None,
                 private_key_id: Optional[pulumi.Input[builtins.str]] = None,
                 project_id: Optional[pulumi.Input[builtins.int]] = None,
                 retries: Optional[pulumi.Input[builtins.int]] = None,
                 timeout_seconds: Optional[pulumi.Input[builtins.int]] = None,
                 token_uri: Optional[pulumi.Input[builtins.str]] = None,
                 type: Optional[pulumi.Input[builtins.str]] = None):
        """
        Input properties used for looking up and filtering BigQueryConnection resources.
        :param pulumi.Input[builtins.str] application_id: The Application ID for BQ OAuth
        :param pulumi.Input[builtins.str] application_secret: The Application Secret for BQ OAuth
        :param pulumi.Input[builtins.str] auth_provider_x509_cert_url: Auth Provider X509 Cert URL for the Service Account
        :param pulumi.Input[builtins.str] auth_uri: Auth URI for the Service Account
        :param pulumi.Input[builtins.str] client_email: Service Account email
        :param pulumi.Input[builtins.str] client_id: Client ID of the Service Account
        :param pulumi.Input[builtins.str] client_x509_cert_url: Client X509 Cert URL for the Service Account
        :param pulumi.Input[builtins.int] connection_id: Connection Identifier
        :param pulumi.Input[builtins.str] dataproc_cluster_name: Dataproc cluster name for PySpark workloads
        :param pulumi.Input[builtins.str] dataproc_region: Google Cloud region for PySpark workloads on Dataproc
        :param pulumi.Input[builtins.str] execution_project: Project to bill for query execution
        :param pulumi.Input[builtins.str] gcp_project_id: GCP project ID
        :param pulumi.Input[builtins.str] gcs_bucket: URI for a Google Cloud Storage bucket to host Python code executed via Datapro
        :param pulumi.Input[builtins.bool] is_active: Whether the connection is active
        :param pulumi.Input[builtins.bool] is_configured_for_oauth: Whether the connection is configured for OAuth or not
        :param pulumi.Input[builtins.str] location: Location to create new Datasets in
        :param pulumi.Input[builtins.int] maximum_bytes_billed: Max number of bytes that can be billed for a given BigQuery query
        :param pulumi.Input[builtins.str] name: Connection name
        :param pulumi.Input[builtins.str] priority: The priority with which to execute BigQuery queries (batch or interactive)
        :param pulumi.Input[builtins.str] private_key: Private key of the Service Account
        :param pulumi.Input[builtins.str] private_key_id: Private key ID of the Service Account
        :param pulumi.Input[builtins.int] project_id: Project ID to create the connection in
        :param pulumi.Input[builtins.int] retries: Number of retries for queries
        :param pulumi.Input[builtins.int] timeout_seconds: Timeout in seconds for queries
        :param pulumi.Input[builtins.str] token_uri: Token URI for the Service Account
        :param pulumi.Input[builtins.str] type: The type of connection
        """
        if application_id is not None:
            pulumi.set(__self__, "application_id", application_id)
        if application_secret is not None:
            pulumi.set(__self__, "application_secret", application_secret)
        if auth_provider_x509_cert_url is not None:
            pulumi.set(__self__, "auth_provider_x509_cert_url", auth_provider_x509_cert_url)
        if auth_uri is not None:
            pulumi.set(__self__, "auth_uri", auth_uri)
        if client_email is not None:
            pulumi.set(__self__, "client_email", client_email)
        if client_id is not None:
            pulumi.set(__self__, "client_id", client_id)
        if client_x509_cert_url is not None:
            pulumi.set(__self__, "client_x509_cert_url", client_x509_cert_url)
        if connection_id is not None:
            pulumi.set(__self__, "connection_id", connection_id)
        if dataproc_cluster_name is not None:
            pulumi.set(__self__, "dataproc_cluster_name", dataproc_cluster_name)
        if dataproc_region is not None:
            pulumi.set(__self__, "dataproc_region", dataproc_region)
        if execution_project is not None:
            pulumi.set(__self__, "execution_project", execution_project)
        if gcp_project_id is not None:
            pulumi.set(__self__, "gcp_project_id", gcp_project_id)
        if gcs_bucket is not None:
            pulumi.set(__self__, "gcs_bucket", gcs_bucket)
        if is_active is not None:
            pulumi.set(__self__, "is_active", is_active)
        if is_configured_for_oauth is not None:
            pulumi.set(__self__, "is_configured_for_oauth", is_configured_for_oauth)
        if location is not None:
            pulumi.set(__self__, "location", location)
        if maximum_bytes_billed is not None:
            pulumi.set(__self__, "maximum_bytes_billed", maximum_bytes_billed)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if priority is not None:
            pulumi.set(__self__, "priority", priority)
        if private_key is not None:
            pulumi.set(__self__, "private_key", private_key)
        if private_key_id is not None:
            pulumi.set(__self__, "private_key_id", private_key_id)
        if project_id is not None:
            pulumi.set(__self__, "project_id", project_id)
        if retries is not None:
            pulumi.set(__self__, "retries", retries)
        if timeout_seconds is not None:
            pulumi.set(__self__, "timeout_seconds", timeout_seconds)
        if token_uri is not None:
            pulumi.set(__self__, "token_uri", token_uri)
        if type is not None:
            pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="applicationId")
    def application_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The Application ID for BQ OAuth
        """
        return pulumi.get(self, "application_id")

    @application_id.setter
    def application_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "application_id", value)

    @property
    @pulumi.getter(name="applicationSecret")
    def application_secret(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The Application Secret for BQ OAuth
        """
        return pulumi.get(self, "application_secret")

    @application_secret.setter
    def application_secret(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "application_secret", value)

    @property
    @pulumi.getter(name="authProviderX509CertUrl")
    def auth_provider_x509_cert_url(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Auth Provider X509 Cert URL for the Service Account
        """
        return pulumi.get(self, "auth_provider_x509_cert_url")

    @auth_provider_x509_cert_url.setter
    def auth_provider_x509_cert_url(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "auth_provider_x509_cert_url", value)

    @property
    @pulumi.getter(name="authUri")
    def auth_uri(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Auth URI for the Service Account
        """
        return pulumi.get(self, "auth_uri")

    @auth_uri.setter
    def auth_uri(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "auth_uri", value)

    @property
    @pulumi.getter(name="clientEmail")
    def client_email(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Service Account email
        """
        return pulumi.get(self, "client_email")

    @client_email.setter
    def client_email(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "client_email", value)

    @property
    @pulumi.getter(name="clientId")
    def client_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Client ID of the Service Account
        """
        return pulumi.get(self, "client_id")

    @client_id.setter
    def client_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "client_id", value)

    @property
    @pulumi.getter(name="clientX509CertUrl")
    def client_x509_cert_url(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Client X509 Cert URL for the Service Account
        """
        return pulumi.get(self, "client_x509_cert_url")

    @client_x509_cert_url.setter
    def client_x509_cert_url(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "client_x509_cert_url", value)

    @property
    @pulumi.getter(name="connectionId")
    def connection_id(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        Connection Identifier
        """
        return pulumi.get(self, "connection_id")

    @connection_id.setter
    def connection_id(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "connection_id", value)

    @property
    @pulumi.getter(name="dataprocClusterName")
    def dataproc_cluster_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Dataproc cluster name for PySpark workloads
        """
        return pulumi.get(self, "dataproc_cluster_name")

    @dataproc_cluster_name.setter
    def dataproc_cluster_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "dataproc_cluster_name", value)

    @property
    @pulumi.getter(name="dataprocRegion")
    def dataproc_region(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Google Cloud region for PySpark workloads on Dataproc
        """
        return pulumi.get(self, "dataproc_region")

    @dataproc_region.setter
    def dataproc_region(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "dataproc_region", value)

    @property
    @pulumi.getter(name="executionProject")
    def execution_project(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Project to bill for query execution
        """
        return pulumi.get(self, "execution_project")

    @execution_project.setter
    def execution_project(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "execution_project", value)

    @property
    @pulumi.getter(name="gcpProjectId")
    def gcp_project_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        GCP project ID
        """
        return pulumi.get(self, "gcp_project_id")

    @gcp_project_id.setter
    def gcp_project_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "gcp_project_id", value)

    @property
    @pulumi.getter(name="gcsBucket")
    def gcs_bucket(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        URI for a Google Cloud Storage bucket to host Python code executed via Datapro
        """
        return pulumi.get(self, "gcs_bucket")

    @gcs_bucket.setter
    def gcs_bucket(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "gcs_bucket", value)

    @property
    @pulumi.getter(name="isActive")
    def is_active(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Whether the connection is active
        """
        return pulumi.get(self, "is_active")

    @is_active.setter
    def is_active(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "is_active", value)

    @property
    @pulumi.getter(name="isConfiguredForOauth")
    def is_configured_for_oauth(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Whether the connection is configured for OAuth or not
        """
        return pulumi.get(self, "is_configured_for_oauth")

    @is_configured_for_oauth.setter
    def is_configured_for_oauth(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "is_configured_for_oauth", value)

    @property
    @pulumi.getter
    def location(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Location to create new Datasets in
        """
        return pulumi.get(self, "location")

    @location.setter
    def location(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "location", value)

    @property
    @pulumi.getter(name="maximumBytesBilled")
    def maximum_bytes_billed(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        Max number of bytes that can be billed for a given BigQuery query
        """
        return pulumi.get(self, "maximum_bytes_billed")

    @maximum_bytes_billed.setter
    def maximum_bytes_billed(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "maximum_bytes_billed", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Connection name
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def priority(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The priority with which to execute BigQuery queries (batch or interactive)
        """
        return pulumi.get(self, "priority")

    @priority.setter
    def priority(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "priority", value)

    @property
    @pulumi.getter(name="privateKey")
    def private_key(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Private key of the Service Account
        """
        return pulumi.get(self, "private_key")

    @private_key.setter
    def private_key(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "private_key", value)

    @property
    @pulumi.getter(name="privateKeyId")
    def private_key_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Private key ID of the Service Account
        """
        return pulumi.get(self, "private_key_id")

    @private_key_id.setter
    def private_key_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "private_key_id", value)

    @property
    @pulumi.getter(name="projectId")
    def project_id(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        Project ID to create the connection in
        """
        return pulumi.get(self, "project_id")

    @project_id.setter
    def project_id(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "project_id", value)

    @property
    @pulumi.getter
    def retries(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        Number of retries for queries
        """
        return pulumi.get(self, "retries")

    @retries.setter
    def retries(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "retries", value)

    @property
    @pulumi.getter(name="timeoutSeconds")
    def timeout_seconds(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        Timeout in seconds for queries
        """
        return pulumi.get(self, "timeout_seconds")

    @timeout_seconds.setter
    def timeout_seconds(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "timeout_seconds", value)

    @property
    @pulumi.getter(name="tokenUri")
    def token_uri(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Token URI for the Service Account
        """
        return pulumi.get(self, "token_uri")

    @token_uri.setter
    def token_uri(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "token_uri", value)

    @property
    @pulumi.getter
    def type(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The type of connection
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "type", value)


class BigQueryConnection(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 application_id: Optional[pulumi.Input[builtins.str]] = None,
                 application_secret: Optional[pulumi.Input[builtins.str]] = None,
                 auth_provider_x509_cert_url: Optional[pulumi.Input[builtins.str]] = None,
                 auth_uri: Optional[pulumi.Input[builtins.str]] = None,
                 client_email: Optional[pulumi.Input[builtins.str]] = None,
                 client_id: Optional[pulumi.Input[builtins.str]] = None,
                 client_x509_cert_url: Optional[pulumi.Input[builtins.str]] = None,
                 dataproc_cluster_name: Optional[pulumi.Input[builtins.str]] = None,
                 dataproc_region: Optional[pulumi.Input[builtins.str]] = None,
                 execution_project: Optional[pulumi.Input[builtins.str]] = None,
                 gcp_project_id: Optional[pulumi.Input[builtins.str]] = None,
                 gcs_bucket: Optional[pulumi.Input[builtins.str]] = None,
                 is_active: Optional[pulumi.Input[builtins.bool]] = None,
                 location: Optional[pulumi.Input[builtins.str]] = None,
                 maximum_bytes_billed: Optional[pulumi.Input[builtins.int]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 priority: Optional[pulumi.Input[builtins.str]] = None,
                 private_key: Optional[pulumi.Input[builtins.str]] = None,
                 private_key_id: Optional[pulumi.Input[builtins.str]] = None,
                 project_id: Optional[pulumi.Input[builtins.int]] = None,
                 retries: Optional[pulumi.Input[builtins.int]] = None,
                 timeout_seconds: Optional[pulumi.Input[builtins.int]] = None,
                 token_uri: Optional[pulumi.Input[builtins.str]] = None,
                 type: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        """
        Resource to create BigQuery connections in dbt Cloud. Can be set to use OAuth for developers.

        > This resource is deprecated and is going to be removed in the next major release, please use the `GlobalConnection` resource instead to create BigQuery connections.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_dbtcloud as dbtcloud

        my_connection = dbtcloud.BigQueryConnection("my_connection",
            project_id=dbt_project["id"],
            name="Project Name",
            type="bigquery",
            is_active=True,
            gcp_project_id="my-gcp-project-id",
            timeout_seconds=100,
            private_key_id="my-private-key-id",
            private_key="ABCDEFGHIJKL",
            client_email="my_client_email",
            client_id="my_client_di",
            auth_uri="my_auth_uri",
            token_uri="my_token_uri",
            auth_provider_x509_cert_url="my_auth_provider_x509_cert_url",
            client_x509_cert_url="my_client_x509_cert_url",
            retries=3)
        # it is also possible to set the connection to use OAuth by filling in `application_id` and `application_secret`
        my_connection_with_oauth = dbtcloud.BigQueryConnection("my_connection_with_oauth",
            project_id=dbt_project["id"],
            name="Project Name",
            type="bigquery",
            is_active=True,
            gcp_project_id="my-gcp-project-id",
            timeout_seconds=100,
            private_key_id="my-private-key-id",
            private_key="ABCDEFGHIJKL",
            client_email="my_client_email",
            client_id="my_client_di",
            auth_uri="my_auth_uri",
            token_uri="my_token_uri",
            auth_provider_x509_cert_url="my_auth_provider_x509_cert_url",
            client_x509_cert_url="my_client_x509_cert_url",
            retries=3,
            application_id="oauth_application_id",
            application_secret="oauth_secret_id")
        ```

        ## Import

        using  import blocks (requires Terraform >= 1.5)

        import {

          to = dbtcloud_bigquery_connection.my_connection

          id = "project_id:connection_id"

        }

        import {

          to = dbtcloud_bigquery_connection.my_connection

          id = "12345:6789"

        }

        using the older import command

        ```sh
        $ pulumi import dbtcloud:index/bigQueryConnection:BigQueryConnection my_connection "project_id:connection_id"
        ```

        ```sh
        $ pulumi import dbtcloud:index/bigQueryConnection:BigQueryConnection my_connection 12345:6789
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] application_id: The Application ID for BQ OAuth
        :param pulumi.Input[builtins.str] application_secret: The Application Secret for BQ OAuth
        :param pulumi.Input[builtins.str] auth_provider_x509_cert_url: Auth Provider X509 Cert URL for the Service Account
        :param pulumi.Input[builtins.str] auth_uri: Auth URI for the Service Account
        :param pulumi.Input[builtins.str] client_email: Service Account email
        :param pulumi.Input[builtins.str] client_id: Client ID of the Service Account
        :param pulumi.Input[builtins.str] client_x509_cert_url: Client X509 Cert URL for the Service Account
        :param pulumi.Input[builtins.str] dataproc_cluster_name: Dataproc cluster name for PySpark workloads
        :param pulumi.Input[builtins.str] dataproc_region: Google Cloud region for PySpark workloads on Dataproc
        :param pulumi.Input[builtins.str] execution_project: Project to bill for query execution
        :param pulumi.Input[builtins.str] gcp_project_id: GCP project ID
        :param pulumi.Input[builtins.str] gcs_bucket: URI for a Google Cloud Storage bucket to host Python code executed via Datapro
        :param pulumi.Input[builtins.bool] is_active: Whether the connection is active
        :param pulumi.Input[builtins.str] location: Location to create new Datasets in
        :param pulumi.Input[builtins.int] maximum_bytes_billed: Max number of bytes that can be billed for a given BigQuery query
        :param pulumi.Input[builtins.str] name: Connection name
        :param pulumi.Input[builtins.str] priority: The priority with which to execute BigQuery queries (batch or interactive)
        :param pulumi.Input[builtins.str] private_key: Private key of the Service Account
        :param pulumi.Input[builtins.str] private_key_id: Private key ID of the Service Account
        :param pulumi.Input[builtins.int] project_id: Project ID to create the connection in
        :param pulumi.Input[builtins.int] retries: Number of retries for queries
        :param pulumi.Input[builtins.int] timeout_seconds: Timeout in seconds for queries
        :param pulumi.Input[builtins.str] token_uri: Token URI for the Service Account
        :param pulumi.Input[builtins.str] type: The type of connection
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: BigQueryConnectionArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Resource to create BigQuery connections in dbt Cloud. Can be set to use OAuth for developers.

        > This resource is deprecated and is going to be removed in the next major release, please use the `GlobalConnection` resource instead to create BigQuery connections.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_dbtcloud as dbtcloud

        my_connection = dbtcloud.BigQueryConnection("my_connection",
            project_id=dbt_project["id"],
            name="Project Name",
            type="bigquery",
            is_active=True,
            gcp_project_id="my-gcp-project-id",
            timeout_seconds=100,
            private_key_id="my-private-key-id",
            private_key="ABCDEFGHIJKL",
            client_email="my_client_email",
            client_id="my_client_di",
            auth_uri="my_auth_uri",
            token_uri="my_token_uri",
            auth_provider_x509_cert_url="my_auth_provider_x509_cert_url",
            client_x509_cert_url="my_client_x509_cert_url",
            retries=3)
        # it is also possible to set the connection to use OAuth by filling in `application_id` and `application_secret`
        my_connection_with_oauth = dbtcloud.BigQueryConnection("my_connection_with_oauth",
            project_id=dbt_project["id"],
            name="Project Name",
            type="bigquery",
            is_active=True,
            gcp_project_id="my-gcp-project-id",
            timeout_seconds=100,
            private_key_id="my-private-key-id",
            private_key="ABCDEFGHIJKL",
            client_email="my_client_email",
            client_id="my_client_di",
            auth_uri="my_auth_uri",
            token_uri="my_token_uri",
            auth_provider_x509_cert_url="my_auth_provider_x509_cert_url",
            client_x509_cert_url="my_client_x509_cert_url",
            retries=3,
            application_id="oauth_application_id",
            application_secret="oauth_secret_id")
        ```

        ## Import

        using  import blocks (requires Terraform >= 1.5)

        import {

          to = dbtcloud_bigquery_connection.my_connection

          id = "project_id:connection_id"

        }

        import {

          to = dbtcloud_bigquery_connection.my_connection

          id = "12345:6789"

        }

        using the older import command

        ```sh
        $ pulumi import dbtcloud:index/bigQueryConnection:BigQueryConnection my_connection "project_id:connection_id"
        ```

        ```sh
        $ pulumi import dbtcloud:index/bigQueryConnection:BigQueryConnection my_connection 12345:6789
        ```

        :param str resource_name: The name of the resource.
        :param BigQueryConnectionArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(BigQueryConnectionArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 application_id: Optional[pulumi.Input[builtins.str]] = None,
                 application_secret: Optional[pulumi.Input[builtins.str]] = None,
                 auth_provider_x509_cert_url: Optional[pulumi.Input[builtins.str]] = None,
                 auth_uri: Optional[pulumi.Input[builtins.str]] = None,
                 client_email: Optional[pulumi.Input[builtins.str]] = None,
                 client_id: Optional[pulumi.Input[builtins.str]] = None,
                 client_x509_cert_url: Optional[pulumi.Input[builtins.str]] = None,
                 dataproc_cluster_name: Optional[pulumi.Input[builtins.str]] = None,
                 dataproc_region: Optional[pulumi.Input[builtins.str]] = None,
                 execution_project: Optional[pulumi.Input[builtins.str]] = None,
                 gcp_project_id: Optional[pulumi.Input[builtins.str]] = None,
                 gcs_bucket: Optional[pulumi.Input[builtins.str]] = None,
                 is_active: Optional[pulumi.Input[builtins.bool]] = None,
                 location: Optional[pulumi.Input[builtins.str]] = None,
                 maximum_bytes_billed: Optional[pulumi.Input[builtins.int]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 priority: Optional[pulumi.Input[builtins.str]] = None,
                 private_key: Optional[pulumi.Input[builtins.str]] = None,
                 private_key_id: Optional[pulumi.Input[builtins.str]] = None,
                 project_id: Optional[pulumi.Input[builtins.int]] = None,
                 retries: Optional[pulumi.Input[builtins.int]] = None,
                 timeout_seconds: Optional[pulumi.Input[builtins.int]] = None,
                 token_uri: Optional[pulumi.Input[builtins.str]] = None,
                 type: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = BigQueryConnectionArgs.__new__(BigQueryConnectionArgs)

            __props__.__dict__["application_id"] = None if application_id is None else pulumi.Output.secret(application_id)
            __props__.__dict__["application_secret"] = None if application_secret is None else pulumi.Output.secret(application_secret)
            if auth_provider_x509_cert_url is None and not opts.urn:
                raise TypeError("Missing required property 'auth_provider_x509_cert_url'")
            __props__.__dict__["auth_provider_x509_cert_url"] = auth_provider_x509_cert_url
            if auth_uri is None and not opts.urn:
                raise TypeError("Missing required property 'auth_uri'")
            __props__.__dict__["auth_uri"] = auth_uri
            if client_email is None and not opts.urn:
                raise TypeError("Missing required property 'client_email'")
            __props__.__dict__["client_email"] = client_email
            if client_id is None and not opts.urn:
                raise TypeError("Missing required property 'client_id'")
            __props__.__dict__["client_id"] = client_id
            if client_x509_cert_url is None and not opts.urn:
                raise TypeError("Missing required property 'client_x509_cert_url'")
            __props__.__dict__["client_x509_cert_url"] = client_x509_cert_url
            __props__.__dict__["dataproc_cluster_name"] = dataproc_cluster_name
            __props__.__dict__["dataproc_region"] = dataproc_region
            __props__.__dict__["execution_project"] = execution_project
            if gcp_project_id is None and not opts.urn:
                raise TypeError("Missing required property 'gcp_project_id'")
            __props__.__dict__["gcp_project_id"] = gcp_project_id
            __props__.__dict__["gcs_bucket"] = gcs_bucket
            __props__.__dict__["is_active"] = is_active
            __props__.__dict__["location"] = location
            __props__.__dict__["maximum_bytes_billed"] = maximum_bytes_billed
            __props__.__dict__["name"] = name
            __props__.__dict__["priority"] = priority
            if private_key is None and not opts.urn:
                raise TypeError("Missing required property 'private_key'")
            __props__.__dict__["private_key"] = None if private_key is None else pulumi.Output.secret(private_key)
            if private_key_id is None and not opts.urn:
                raise TypeError("Missing required property 'private_key_id'")
            __props__.__dict__["private_key_id"] = private_key_id
            if project_id is None and not opts.urn:
                raise TypeError("Missing required property 'project_id'")
            __props__.__dict__["project_id"] = project_id
            __props__.__dict__["retries"] = retries
            if timeout_seconds is None and not opts.urn:
                raise TypeError("Missing required property 'timeout_seconds'")
            __props__.__dict__["timeout_seconds"] = timeout_seconds
            if token_uri is None and not opts.urn:
                raise TypeError("Missing required property 'token_uri'")
            __props__.__dict__["token_uri"] = token_uri
            if type is None and not opts.urn:
                raise TypeError("Missing required property 'type'")
            __props__.__dict__["type"] = type
            __props__.__dict__["connection_id"] = None
            __props__.__dict__["is_configured_for_oauth"] = None
        secret_opts = pulumi.ResourceOptions(additional_secret_outputs=["applicationId", "applicationSecret", "privateKey"])
        opts = pulumi.ResourceOptions.merge(opts, secret_opts)
        super(BigQueryConnection, __self__).__init__(
            'dbtcloud:index/bigQueryConnection:BigQueryConnection',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            application_id: Optional[pulumi.Input[builtins.str]] = None,
            application_secret: Optional[pulumi.Input[builtins.str]] = None,
            auth_provider_x509_cert_url: Optional[pulumi.Input[builtins.str]] = None,
            auth_uri: Optional[pulumi.Input[builtins.str]] = None,
            client_email: Optional[pulumi.Input[builtins.str]] = None,
            client_id: Optional[pulumi.Input[builtins.str]] = None,
            client_x509_cert_url: Optional[pulumi.Input[builtins.str]] = None,
            connection_id: Optional[pulumi.Input[builtins.int]] = None,
            dataproc_cluster_name: Optional[pulumi.Input[builtins.str]] = None,
            dataproc_region: Optional[pulumi.Input[builtins.str]] = None,
            execution_project: Optional[pulumi.Input[builtins.str]] = None,
            gcp_project_id: Optional[pulumi.Input[builtins.str]] = None,
            gcs_bucket: Optional[pulumi.Input[builtins.str]] = None,
            is_active: Optional[pulumi.Input[builtins.bool]] = None,
            is_configured_for_oauth: Optional[pulumi.Input[builtins.bool]] = None,
            location: Optional[pulumi.Input[builtins.str]] = None,
            maximum_bytes_billed: Optional[pulumi.Input[builtins.int]] = None,
            name: Optional[pulumi.Input[builtins.str]] = None,
            priority: Optional[pulumi.Input[builtins.str]] = None,
            private_key: Optional[pulumi.Input[builtins.str]] = None,
            private_key_id: Optional[pulumi.Input[builtins.str]] = None,
            project_id: Optional[pulumi.Input[builtins.int]] = None,
            retries: Optional[pulumi.Input[builtins.int]] = None,
            timeout_seconds: Optional[pulumi.Input[builtins.int]] = None,
            token_uri: Optional[pulumi.Input[builtins.str]] = None,
            type: Optional[pulumi.Input[builtins.str]] = None) -> 'BigQueryConnection':
        """
        Get an existing BigQueryConnection resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] application_id: The Application ID for BQ OAuth
        :param pulumi.Input[builtins.str] application_secret: The Application Secret for BQ OAuth
        :param pulumi.Input[builtins.str] auth_provider_x509_cert_url: Auth Provider X509 Cert URL for the Service Account
        :param pulumi.Input[builtins.str] auth_uri: Auth URI for the Service Account
        :param pulumi.Input[builtins.str] client_email: Service Account email
        :param pulumi.Input[builtins.str] client_id: Client ID of the Service Account
        :param pulumi.Input[builtins.str] client_x509_cert_url: Client X509 Cert URL for the Service Account
        :param pulumi.Input[builtins.int] connection_id: Connection Identifier
        :param pulumi.Input[builtins.str] dataproc_cluster_name: Dataproc cluster name for PySpark workloads
        :param pulumi.Input[builtins.str] dataproc_region: Google Cloud region for PySpark workloads on Dataproc
        :param pulumi.Input[builtins.str] execution_project: Project to bill for query execution
        :param pulumi.Input[builtins.str] gcp_project_id: GCP project ID
        :param pulumi.Input[builtins.str] gcs_bucket: URI for a Google Cloud Storage bucket to host Python code executed via Datapro
        :param pulumi.Input[builtins.bool] is_active: Whether the connection is active
        :param pulumi.Input[builtins.bool] is_configured_for_oauth: Whether the connection is configured for OAuth or not
        :param pulumi.Input[builtins.str] location: Location to create new Datasets in
        :param pulumi.Input[builtins.int] maximum_bytes_billed: Max number of bytes that can be billed for a given BigQuery query
        :param pulumi.Input[builtins.str] name: Connection name
        :param pulumi.Input[builtins.str] priority: The priority with which to execute BigQuery queries (batch or interactive)
        :param pulumi.Input[builtins.str] private_key: Private key of the Service Account
        :param pulumi.Input[builtins.str] private_key_id: Private key ID of the Service Account
        :param pulumi.Input[builtins.int] project_id: Project ID to create the connection in
        :param pulumi.Input[builtins.int] retries: Number of retries for queries
        :param pulumi.Input[builtins.int] timeout_seconds: Timeout in seconds for queries
        :param pulumi.Input[builtins.str] token_uri: Token URI for the Service Account
        :param pulumi.Input[builtins.str] type: The type of connection
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _BigQueryConnectionState.__new__(_BigQueryConnectionState)

        __props__.__dict__["application_id"] = application_id
        __props__.__dict__["application_secret"] = application_secret
        __props__.__dict__["auth_provider_x509_cert_url"] = auth_provider_x509_cert_url
        __props__.__dict__["auth_uri"] = auth_uri
        __props__.__dict__["client_email"] = client_email
        __props__.__dict__["client_id"] = client_id
        __props__.__dict__["client_x509_cert_url"] = client_x509_cert_url
        __props__.__dict__["connection_id"] = connection_id
        __props__.__dict__["dataproc_cluster_name"] = dataproc_cluster_name
        __props__.__dict__["dataproc_region"] = dataproc_region
        __props__.__dict__["execution_project"] = execution_project
        __props__.__dict__["gcp_project_id"] = gcp_project_id
        __props__.__dict__["gcs_bucket"] = gcs_bucket
        __props__.__dict__["is_active"] = is_active
        __props__.__dict__["is_configured_for_oauth"] = is_configured_for_oauth
        __props__.__dict__["location"] = location
        __props__.__dict__["maximum_bytes_billed"] = maximum_bytes_billed
        __props__.__dict__["name"] = name
        __props__.__dict__["priority"] = priority
        __props__.__dict__["private_key"] = private_key
        __props__.__dict__["private_key_id"] = private_key_id
        __props__.__dict__["project_id"] = project_id
        __props__.__dict__["retries"] = retries
        __props__.__dict__["timeout_seconds"] = timeout_seconds
        __props__.__dict__["token_uri"] = token_uri
        __props__.__dict__["type"] = type
        return BigQueryConnection(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="applicationId")
    def application_id(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        The Application ID for BQ OAuth
        """
        return pulumi.get(self, "application_id")

    @property
    @pulumi.getter(name="applicationSecret")
    def application_secret(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        The Application Secret for BQ OAuth
        """
        return pulumi.get(self, "application_secret")

    @property
    @pulumi.getter(name="authProviderX509CertUrl")
    def auth_provider_x509_cert_url(self) -> pulumi.Output[builtins.str]:
        """
        Auth Provider X509 Cert URL for the Service Account
        """
        return pulumi.get(self, "auth_provider_x509_cert_url")

    @property
    @pulumi.getter(name="authUri")
    def auth_uri(self) -> pulumi.Output[builtins.str]:
        """
        Auth URI for the Service Account
        """
        return pulumi.get(self, "auth_uri")

    @property
    @pulumi.getter(name="clientEmail")
    def client_email(self) -> pulumi.Output[builtins.str]:
        """
        Service Account email
        """
        return pulumi.get(self, "client_email")

    @property
    @pulumi.getter(name="clientId")
    def client_id(self) -> pulumi.Output[builtins.str]:
        """
        Client ID of the Service Account
        """
        return pulumi.get(self, "client_id")

    @property
    @pulumi.getter(name="clientX509CertUrl")
    def client_x509_cert_url(self) -> pulumi.Output[builtins.str]:
        """
        Client X509 Cert URL for the Service Account
        """
        return pulumi.get(self, "client_x509_cert_url")

    @property
    @pulumi.getter(name="connectionId")
    def connection_id(self) -> pulumi.Output[builtins.int]:
        """
        Connection Identifier
        """
        return pulumi.get(self, "connection_id")

    @property
    @pulumi.getter(name="dataprocClusterName")
    def dataproc_cluster_name(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        Dataproc cluster name for PySpark workloads
        """
        return pulumi.get(self, "dataproc_cluster_name")

    @property
    @pulumi.getter(name="dataprocRegion")
    def dataproc_region(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        Google Cloud region for PySpark workloads on Dataproc
        """
        return pulumi.get(self, "dataproc_region")

    @property
    @pulumi.getter(name="executionProject")
    def execution_project(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        Project to bill for query execution
        """
        return pulumi.get(self, "execution_project")

    @property
    @pulumi.getter(name="gcpProjectId")
    def gcp_project_id(self) -> pulumi.Output[builtins.str]:
        """
        GCP project ID
        """
        return pulumi.get(self, "gcp_project_id")

    @property
    @pulumi.getter(name="gcsBucket")
    def gcs_bucket(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        URI for a Google Cloud Storage bucket to host Python code executed via Datapro
        """
        return pulumi.get(self, "gcs_bucket")

    @property
    @pulumi.getter(name="isActive")
    def is_active(self) -> pulumi.Output[Optional[builtins.bool]]:
        """
        Whether the connection is active
        """
        return pulumi.get(self, "is_active")

    @property
    @pulumi.getter(name="isConfiguredForOauth")
    def is_configured_for_oauth(self) -> pulumi.Output[builtins.bool]:
        """
        Whether the connection is configured for OAuth or not
        """
        return pulumi.get(self, "is_configured_for_oauth")

    @property
    @pulumi.getter
    def location(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        Location to create new Datasets in
        """
        return pulumi.get(self, "location")

    @property
    @pulumi.getter(name="maximumBytesBilled")
    def maximum_bytes_billed(self) -> pulumi.Output[Optional[builtins.int]]:
        """
        Max number of bytes that can be billed for a given BigQuery query
        """
        return pulumi.get(self, "maximum_bytes_billed")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[builtins.str]:
        """
        Connection name
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def priority(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        The priority with which to execute BigQuery queries (batch or interactive)
        """
        return pulumi.get(self, "priority")

    @property
    @pulumi.getter(name="privateKey")
    def private_key(self) -> pulumi.Output[builtins.str]:
        """
        Private key of the Service Account
        """
        return pulumi.get(self, "private_key")

    @property
    @pulumi.getter(name="privateKeyId")
    def private_key_id(self) -> pulumi.Output[builtins.str]:
        """
        Private key ID of the Service Account
        """
        return pulumi.get(self, "private_key_id")

    @property
    @pulumi.getter(name="projectId")
    def project_id(self) -> pulumi.Output[builtins.int]:
        """
        Project ID to create the connection in
        """
        return pulumi.get(self, "project_id")

    @property
    @pulumi.getter
    def retries(self) -> pulumi.Output[Optional[builtins.int]]:
        """
        Number of retries for queries
        """
        return pulumi.get(self, "retries")

    @property
    @pulumi.getter(name="timeoutSeconds")
    def timeout_seconds(self) -> pulumi.Output[builtins.int]:
        """
        Timeout in seconds for queries
        """
        return pulumi.get(self, "timeout_seconds")

    @property
    @pulumi.getter(name="tokenUri")
    def token_uri(self) -> pulumi.Output[builtins.str]:
        """
        Token URI for the Service Account
        """
        return pulumi.get(self, "token_uri")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[builtins.str]:
        """
        The type of connection
        """
        return pulumi.get(self, "type")

